diff -ruN ../nakedmudv3.7.9/src/scripts/pychar.c src/scripts/pychar.c
--- ../nakedmudv3.7.9/src/scripts/pychar.c	2009-03-02 01:00:40.000000000 -0500
+++ src/scripts/pychar.c	2009-04-05 16:39:24.000000000 -0400
@@ -33,6 +33,7 @@
 #include "pyexit.h"
 #include "pyaccount.h"
 #include "pyauxiliary.h"
+#include "pystorage.h"
 
 
 
@@ -479,6 +480,8 @@
     charSetWeight(ch, 0.0);
   else if(PyFloat_Check(value))
     charSetWeight(ch, PyFloat_AsDouble(value));
+  else if(PyInt_Check(value))
+    charSetWeight(ch, PyInt_AsLong(value));
   else {
     PyErr_Format(PyExc_TypeError,
 		"Tried to change char %d's weight to an invalid type.",
@@ -734,7 +737,7 @@
 
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
   if(ch) {
-    send_to_char(ch, "%s", mssg);
+    text_to_char(ch, mssg);
     return Py_BuildValue("i", 1);
   }
   else {
@@ -746,22 +749,71 @@
 }
 
 //
-// sends a newline-tagged message to the character
-PyObject *PyChar_send(PyChar *self, PyObject *value) {
-  PyObject *retval = PyChar_send_raw(self, value);
-  if(retval == NULL)
+// Send a message with Python statements potentially embedded in it. For 
+//evaluating 
+PyObject *PyChar_send(PyObject *self, PyObject *args, PyObject *kwds) {
+  static char *kwlist[] = { "mssg", "dict", "newline", NULL };
+  CHAR_DATA  *me = NULL;
+  char     *text = NULL;
+  PyObject *dict = NULL;
+  bool   newline = TRUE;
+
+  if(!PyArg_ParseTupleAndKeywords(args, kwds, "s|Ob", kwlist, 
+				  &text, &dict, &newline)) {
+    PyErr_Format(PyExc_TypeError, "Char.send takes a message, a dictionary, and possibly a newline option.");
     return NULL;
-  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
-  send_to_char(ch, "\r\n");
-  Py_DECREF(retval);
-  return Py_BuildValue("i", 1);
+  }
+
+  // make sure the dictionary is a dictionary
+  if(dict != NULL && !(PyDict_Check(dict) || dict == Py_None)) {
+    PyErr_Format(PyExc_TypeError, "char.send expects second argument to be a dict object.");
+    return NULL;
+  }
+  
+  // make sure we exist
+  if( (me = PyChar_AsChar(self)) == NULL) {
+    PyErr_Format(PyExc_TypeError, "Tried to send nonexistant character.");
+    return NULL;
+  }
+
+  // the text we are sending
+  BUFFER *buf = newBuffer(1);
+  bprintf(buf, "%s%s", text, (newline ? "\r\n" : ""));
+  
+  // are we sending as-is, or expanding embedded statements?
+  if(dict != NULL) {
+    // build the script dictionary
+    PyObject *script_dict = restricted_script_dict();
+    if(dict != Py_None)
+      PyDict_Update(script_dict, dict);
+    PyDict_SetItemString(script_dict, "me", self);
+
+    // do the expansion
+    expand_dynamic_descs_dict(buf, script_dict, get_script_locale());
+
+    // garbage collection and end
+    Py_XDECREF(script_dict);
+  }
+
+  // send the message
+  text_to_char(me, bufferString(buf));
+
+  // build the return value
+  PyObject *ret = Py_BuildValue("s", bufferString(buf));
+
+  // garbage collection
+  deleteBuffer(buf);
+
+  // return the value
+  return ret;
 }
 
 //
 // Send a newline-tagged message to everyone around the character
 PyObject *PyChar_sendaround(PyChar *self, PyObject *value) {
-  char *mssg = NULL;
-  if (!PyArg_ParseTuple(value, "s", &mssg)) {
+  char   *mssg = NULL;
+  bool newline = TRUE;
+  if (!PyArg_ParseTuple(value, "s|b", &mssg, &newline)) {
     PyErr_Format(PyExc_TypeError, 
                     "Characters may only be sent strings");
     return NULL;
@@ -769,7 +821,7 @@
 
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
   if(ch) {
-    send_around_char(ch, FALSE, "%s\r\n", mssg);
+    send_around_char(ch, FALSE, "%s%s", mssg, (newline ? "\r\n" : ""));
     return Py_BuildValue("i", 1);
   }
   else {
@@ -1519,6 +1571,30 @@
   }
 }
 
+PyObject *PyChar_store(PyObject *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar(self);
+  if(ch == NULL) {
+    PyErr_Format(PyExc_TypeError, "failed to store nonexistent character.");
+    return NULL;
+  }
+  return newPyStorageSet(charStore(ch));
+}
+
+PyObject *PyChar_copy(PyObject *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar(self);
+  if(ch == NULL) {
+    PyErr_Format(PyExc_TypeError, "failed to copy nonexistent character.");
+    return NULL;
+  }
+  CHAR_DATA *newch = charCopy(ch);
+
+  // we have to put the object in the global tables and list, 
+  // or else Python will not be able to access it
+  char_to_game(newch);
+
+  return charGetPyForm(newch);
+}
+
 
 
 //*****************************************************************************
@@ -1783,6 +1859,22 @@
   return list;
 }
 
+PyObject *PyChar_read(PyObject *self, PyObject *args) {
+  PyObject *pyset = NULL;
+  if(!PyArg_ParseTuple(args, "O", &pyset)) {
+    PyErr_Format(PyExc_TypeError, "failed to read character from storage set.");
+    return NULL;
+  }
+  else if(!PyStorageSet_Check(pyset)) {
+    PyErr_Format(PyExc_TypeError, "storage set must be supplied to read.");
+    return NULL;
+  }
+
+  CHAR_DATA *ch = charRead(PyStorageSet_AsSet(pyset));
+  char_to_game(ch);
+  return Py_BuildValue("O", charGetPyFormBorrowed(ch));
+}
+
 PyObject *PyChar_is_abstract(PyObject *self, PyObject *args) {
   char     *mob_key = NULL;
   if (!PyArg_ParseTuple(args, "s", &mob_key)) {
@@ -1800,18 +1892,33 @@
 }
 
 PyMethodDef char_module_methods[] = {
+  { "read",     PyChar_read, METH_VARARGS,
+    "read(storage_set)\n"
+    "\n"
+    "Read and return a character from a storage set." },
   { "char_list", (PyCFunction)PyChar_all_chars, METH_NOARGS,
-    "Return a python list containing an entry for every character in game." },
+    "char_list()\n"
+    "\n"
+    "Return a list of every character in game." },
   { "load_mob", PyChar_load_mob, METH_VARARGS,
-    "load a mobile with the specified prototype to a room." },
+    "load_mob(proto, room, pos = 'standing')\n"
+    "\n"
+    "Generate a new mobile from the specified prototype. Add it to the\n"
+    "given room. Return the created mobile." },
   { "count_mobs", PyChar_count_mobs, METH_VARARGS,
-    "count how many occurances of a mobile there are in the specified scope. "
-    "prototype or name can be used." },
+    "count_mobs(keyword, loc = None)\n"
+    "\n"
+    "count how many occurences of a mobile with the specified keyword, uid,\n"
+    "or prototype exist at a location. If loc is None, search the entire mud.\n"
+    "Loc can be a room, room prototype, or furniture object." },
   { "find_char_key", PyChar_find_char_key, METH_VARARGS,
-    "finds a character (or group of chars) by their prototype. Finding by "
-    "keywords is done with generic_find()" },
+    "Function has been deprecated. Entrypoint for generic_find()\n"
+    "Use mud.parse_args instead."  },
   { "is_abstract",   PyChar_is_abstract, METH_VARARGS,
-    "Returns whether a mob with the specified prototype is abstract." },
+    "is_abstract(proto)\n"
+    "\n"
+    "Returns whether a specified mob prototype is abstract. Also return True\n"
+    "if the prototype does not exist." },
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
@@ -1854,141 +1961,231 @@
 
   // add in our setters and getters for the char class
   PyChar_addGetSetter("inv", PyChar_getinv, NULL,
-		      "returns a list of objects in the char's inventory");
+    "An immutable list of objects in the character's inventory.\n"
+    "See obj.Obj.carrier for altering an item's carrier.");
   PyChar_addGetSetter("objs", PyChar_getinv, NULL,
-		      "returns a list of objects in the char's inventory");
+    "An alias for inv to be consistent with how room and object contents are\n"
+    "accessed.");
   PyChar_addGetSetter("eq",   PyChar_geteq,  NULL,
-		      "returns a list of the character's equipment.");
+    "An immutable list of the character's worn equipment.\n"
+    "See equip() and unequip() for altering a characters worn items.");
   PyChar_addGetSetter("bodyparts", PyChar_getbodyparts, NULL,
-		      "Returns a list of the character's bodyparts");
+    "An immutable list naming all of the character's bodyparts.");
   PyChar_addGetSetter("name", PyChar_getname, PyChar_setname,
-		      "handle the character's name");
+    "The characer's name, e.g., Grunald the Baker.");
   PyChar_addGetSetter("mname", PyChar_getmname, PyChar_setmname,
-		      "handle the character's multi-name");
+    "The character's name for describing packs, e.g.,\n"
+    "a horde of 9001 mosquitos. The number should be replaced by %d, or not\n"
+    "included.");
   PyChar_addGetSetter("desc", PyChar_getdesc, PyChar_setdesc,
-		      "handle the character's description");
+    "A character's verbose description for e.g., when they are looked at.");
   PyChar_addGetSetter("look_buf", PyChar_getlookbuf, PyChar_setlookbuf,
-		      "handle the character's look buffer");
+    "When characters look at something, the thing's description is copied to\n"
+    "the character's look buffer for processing before being sent.");
   PyChar_addGetSetter("rdesc", PyChar_getrdesc, PyChar_setrdesc,
-		      "handle the character's room description");
+    "The character's description when seen in a room, e.g., \n"
+    "Bob is here, baking a cake.");
   PyChar_addGetSetter("mdesc", PyChar_getmdesc, PyChar_setmdesc,
-		      "handle the character's multi room description");
+    "The equivalent of mname, for room descriptions.");
   PyChar_addGetSetter("keywords", PyChar_getkeywords, PyChar_setkeywords,
-		      "comma-separated list of the character's keywords.");
+    "A comma-separated list of the keywords for referencing the character.");
   PyChar_addGetSetter("sex", PyChar_getsex, PyChar_setsex,
-		      "handle the character's gender");
+    "The character's sex. Can be male, female, or neutral.");
   PyChar_addGetSetter("gender", PyChar_getsex, PyChar_setsex,
-		      "handle the character's gender");
+    "Alias for char.Char.sex");
   PyChar_addGetSetter("race", PyChar_getrace, PyChar_setrace,
-		      "handle the character's race");
+    "The character's race.");
   PyChar_addGetSetter("pos", PyChar_getposition, PyChar_setposition,
-		      "handle the character's position");
+    "Alias for char.Char.position.");
   PyChar_addGetSetter("position", PyChar_getposition, PyChar_setposition,
-		      "handle the character's position");
+    "The character's current position (e.g., standing, sleeping, sitting).");
   PyChar_addGetSetter("room", PyChar_getroom, PyChar_setroom,
-		      "handle the character's room");
+    "The current room a character is in. Can be set by room or room key.");
   PyChar_addGetSetter("last_room", PyChar_getlastroom, NULL,
-		      "the last room the character was in");
+    "The last room a character was in. Immutable. Value is None if character\n"
+    "was not previously in a room.");
   PyChar_addGetSetter("on", PyChar_geton, PyChar_seton,
-   "The furniture the character is sitting on/at. If the character is not "
-   "on furniture, None is returned. To remove a character from furniture, "
-  "then use None");
+   "The furniture the character is sitting on/at. Value is None if character\n"
+   "is not currently on furniture. Set value to None to remove a character\n"
+   "from their furniture.");
   PyChar_addGetSetter("uid", PyChar_getuid, NULL,
-		      "the character's unique identification number");
+    "The character's unique identification number. Immutable.");
   PyChar_addGetSetter("prototypes", PyChar_getprototypes, NULL,
-		      "The prototypes for a mobile");
+   "A comma-separated list of prototypes the mobile inherits from. Immutable.");
   PyChar_addGetSetter("mob_class", PyChar_getclass, NULL,
-		      "The main prototype of the mobile.");
+    "The main prototype the mobile inherits from. Immutable.");
   PyChar_addGetSetter("is_npc", PyChar_getisnpc, NULL,
-		      "Returns 1 if the char is an NPC, and 0 otherwise.");
+    "Value is True if character is an NPC, and False otherwise. Immutable.");
   PyChar_addGetSetter("is_pc", PyChar_getispc, NULL,
-		      "Returns 1 if the char is a PC, and 0 otherwise.");
+    "Value is negation of char.Char.is_npc");
   PyChar_addGetSetter("hisher", PyChar_gethisher, NULL,
-		      "Returns 'his' if the char is male, 'her' if female, and "
-		      "'its' for neuters");
+    "Value is 'his', 'her', or 'its'. Immutable.");
   PyChar_addGetSetter("himher", PyChar_gethimher, NULL,
-		      "Returns 'him' if the char is male, 'her' if female, and "
-		      "'it' for neuters");
+    "Value is 'him', 'her', or 'it'. Immutable.");
   PyChar_addGetSetter("heshe", PyChar_getheshe, NULL,
-		      "Returns 'he' if the char is male, 'she' if female, and "
-		      "'it' for neuters");
+    "Value is 'he', 'she', or 'it'. Immutable.");
   PyChar_addGetSetter("user_groups", PyChar_getusergroups, NULL,
-		      "Returns the character's user groups");
+    "A comma-separated list of user groups the character belongs to.\n"
+    "Use char.Char.isInGroup(group) to check for a specific group. Immutable.");
   PyChar_addGetSetter("socket", PyChar_getsocket, NULL,
-		      "Returns the character's socket if it exists.");
+    "The current socket this character is attached to. Value is None if \n"
+    "socket does not exist. Immutable. Use mudsys.attach_char_socket to \n"
+    "attach a character and socket to each other.");
   PyChar_addGetSetter("sock",   PyChar_getsocket, NULL,
-		      "Returns the character's socket if it exists.");
+    "Alias for char.Char.socket");
   PyChar_addGetSetter("hidden", PyChar_gethidden, PyChar_sethidden,
-		      "integer value representing how hidden the char is.");
+    "Integer value representing how hidden the character is. Default is 0.");
   PyChar_addGetSetter("weight", PyChar_getweight, PyChar_setweight,
-		      "double value representing how heavy we are.");
+    "Floating point value representing how heavy the character is.");
   PyChar_addGetSetter("age", PyChar_getage, NULL,
-		      "how old, in seconds, are we");
+    "Value is the difference between the character's creation time and the\n"
+    "current system time. Immutable.");
   PyChar_addGetSetter("birth", PyChar_getbirth, NULL,
-		      "when were we created");
+    "Value is the character's creation time (system time). Immutable.");
 
   // add in all of our methods for the Char class
   PyChar_addMethod("attach", PyChar_attach, METH_VARARGS,
-		   "attach a new script to the character.");
+    "attach(trigger)\n"
+    "\n"
+    "Attach a trigger to the character by key name.");
   PyChar_addMethod("detach", PyChar_detach, METH_VARARGS,
-		   "detach an old script from the character.");
-  PyChar_addMethod("send", PyChar_send, METH_VARARGS,
-		   "send a message to the character with appended newline.");
+    "detach(trigger)\n"
+    "\n"
+    "Detach a trigger from the character by key name.");
+  PyChar_addMethod("send", PyChar_send, METH_KEYWORDS,
+    "send(mssg, script_dict = None, newline = True)\n"
+    "\n"
+    "Sends message to the character. Messages can have scripts embedded in\n" 
+    "them, using [ and ]. If so, a variable dictionary must be provided. By\n"
+    "default, 'me' references the character being sent the message.");
   PyChar_addMethod("send_raw", PyChar_send_raw, METH_VARARGS,
-		   "send a message to the character.");
+    "send_raw(mssg)\n"
+    "\n"
+    "Sends message to the character with no newline appended.");
   PyChar_addMethod("sendaround", PyChar_sendaround, METH_VARARGS,
-		   "send a message to everyone around the character.");
+    "sendaround(mssg, newline=True)\n"
+    "\n"
+    "Sends message to everyone else in the same room as the character.");
   PyChar_addMethod("act", PyChar_act, METH_VARARGS,
-		   "make the character perform an action.");
+    "act(command)\n"
+    "\n"
+    "Simulate a character typing in a command.");
   PyChar_addMethod("getvar", PyChar_getvar, METH_VARARGS,
-		   "get the value of a special variable the character has.");
+    "getvar(name)\n"
+    "\n"
+    "Return value of a special variable. Return 0 if no value has been set.");
   PyChar_addMethod("setvar", PyChar_setvar, METH_VARARGS,
-		   "set the value of a special variable the character has.");
+    "setvar(name, val)\n"
+    "\n"
+    "Set value of a special variable for the character. Values must be\n"
+    "strings or numbers. This function is intended to allow scripts and\n"
+    "triggers to open-endedly add variables to characters.");
   PyChar_addMethod("hasvar", PyChar_hasvar, METH_VARARGS,
-		   "return whether or not the character has a given variable.");
+    "hasvar(name)\n"
+    "\n"
+    "Return True if a character has the given special variable. False otherwise.");
   PyChar_addMethod("deletevar", PyChar_deletevar, METH_VARARGS,
-		   "delete a variable from the character's variable table.");
+    "deletevar(name)\n"
+    "\n"
+    "Deletes a special variable from a character if they have one by the\n"
+    "given name.");
   PyChar_addMethod("delvar", PyChar_deletevar, METH_VARARGS,
-		   "delete a variable from the character's variable table.");
+    "Alias for char.Char.deletevar(name)");
   PyChar_addMethod("equip", PyChar_equip, METH_VARARGS,
-		   "equips a character with the given item. Removes the item "
-		   "from whatever it is currently in/on.");
+    "equip(obj, positions=None, forced=False)\n"
+    "\n"
+    "Attempts to equip an object to the character's body. Positions can be a\n"
+    "comma-separated list of position names or position types. If positions\n"
+    "is None and object is of type 'worn', attempt to equip the object to\n"
+    "its default positions. Setting forced to True allows non-worn objects\n"
+    "to be equipped, or worn objects to be equipped to their non-default\n"
+    "positions. Returns success of attempt.");
   PyChar_addMethod("get_equip", PyChar_getequip, METH_VARARGS,
-		   "Returns the person's equipment in the specified slot.");
+    "get_equip(bodypart)\n"
+    "\n"
+    "Returns object currently equipped to the character's bodypart, or None.");
   PyChar_addMethod("get_slots", PyChar_getslots, METH_VARARGS,
-		   "Returns the slots occupied by the piece of equipment.");
+    "get_slots(obj)\n"
+    "\n"
+    "Returns a comma-separated list of bodypart names currently occupied by\n"
+    "the object.");
   PyChar_addMethod("get_slot_types", PyChar_getslottypes, METH_VARARGS,
-		   "Returns the slot types occupied by the equipment.");
+    "get_slot_types(obj)\n"
+    "\n"
+    "Returns a list of the bodypart types currently occupied by the object.\n"
+    "Returns an empty list of the object is not equipped to this character.");
   PyChar_addMethod("get_bodypct", PyChar_getbodypct, METH_VARARGS,
-		   "Returns the percent mass of the character's body taken up "
-		   "by the specified parts.");
+    "get_bodypct(posnames)\n"
+    "\n"
+    "Returns the percent mass of the character's body taken up by the\n"
+    "specified parts. Bodyparts must be a comma-separated list.");
   PyChar_addMethod("isActing", PyChar_is_acting, METH_NOARGS,
-		   "Returns True if the character is currently taking an "
-		   "action, and False otherwise.");
+    "isActing()\n"
+    "\n"
+    "Returns True if the character is currently taking an action, and False\n"
+    "otherwise.");
   PyChar_addMethod("startAction", PyChar_start_action, METH_VARARGS,
-		   "Begins the character starting a new action");
+    "startAction(delay, on_complete, on_interrupt=None, data=None, arg='')\n"
+    "\n"
+    "Begins a new delayed action for the character. Delay is in seconds.\n"
+    "on_complete is a function taking three arguments: the character, the\n"
+    "data, and the argument. Argument must be a string, data can be anything.\n"
+    "on_interrupt takes the same arguments as on_complete, but is instead\n"
+    "called if the character's action is interrupted.");
   PyChar_addMethod("interrupt", PyChar_interrupt_action, METH_NOARGS,
-		   "Interrupts the character's current action.");
+    "interrupt()\n"
+    "\n"
+    "Cancel any action the character is currently taking.");
   PyChar_addMethod("getAuxiliary", PyChar_get_auxiliary, METH_VARARGS,
-		   "get's the specified piece of aux data from the char");
+    "getAuxiliary(name)\n"
+    "\n"
+    "Returns character's auxiliary data of the specified name.");
   PyChar_addMethod("aux", PyChar_get_auxiliary, METH_VARARGS,
-		   "get's the specified piece of aux data from the char");
+    "Alias for char.Char.getAuxiliary(name)");
   PyChar_addMethod("cansee", PyChar_cansee, METH_VARARGS,
-		   "returns whether or not a char can see an obj or mob.");
+    "cansee(thing)\n"
+    "\n"
+    "Returns whether a character can see the specified object, exit, or other\n"
+    "character.");
   PyChar_addMethod("see_as", PyChar_see_as, METH_VARARGS,
-		   "returns what the character sees the thing as.");
+    "see_as(thing)\n"
+    "\n"
+    "Returns the name by which a character sees a specified object, exit, or\n"
+    "other character.");
   PyChar_addMethod("page", PyChar_page, METH_VARARGS,
-		   "page a bunch of text to the character.");
+    "page(text)\n"
+    "\n"
+    "Send text to the character in paginated form e.g., for helpfiles and\n."
+    "other large blocks of text.");
   PyChar_addMethod("isinstance", PyChar_isinstance, METH_VARARGS,
-		   "returns whether or not the char inherits from the proto");
+    "isinstance(prototype)\n"
+    "\n"
+    "returns whether the character inherits from a specified mob prototype.");
   PyChar_addMethod("isInGroup", PyChar_is_in_groups, METH_VARARGS,
-		   "returns whether or not the character belongs to one of the groups");
+    "isInGroup(usergroup)\n"
+    "\n"
+    "Returns whether a character belongs to a specified user group.");
   PyChar_addMethod("hasPrefs", PyChar_hasPreferences, METH_VARARGS,
-		   "Return if the character has the specified preference.");
+    "hasPrefs(char_prefs)\n"
+    "\n"
+    "Return whether character has any of the specified character preferences.\n"
+    "Multiples can be specified as a comma-separated string.");
   PyChar_addMethod("append_look", PyChar_append_look, METH_VARARGS,
-		   "Append text to the character's look buffer.");
+    "append_look(text)\n"
+    "\n"
+    "Adds text to the character's current look buffer.");
   PyChar_addMethod("clear_look",  PyChar_clear_look, METH_VARARGS,
-		   "Clear the character's look buffer.");
+    "clear_look()\n"
+    "\n"
+    "Clear the character's current look buffer.");
+  PyChar_addMethod("store", PyChar_store, METH_NOARGS,
+    "store()\n"
+    "\n"
+    "Return a storage set representing the character.");
+  PyChar_addMethod("copy", PyChar_copy, METH_NOARGS,
+    "copy()\n"
+    "\n"
+    "Returns a copy of the character.");
 
   // add in all the getsetters and methods
   makePyType(&PyChar_Type, pychar_getsetters, pychar_methods);
@@ -2001,7 +2198,8 @@
 
   // load the module
   m = Py_InitModule3("char", char_module_methods,
-		     "The char module, for all char/mob-related MUD stuff.");
+    "Contains the Python wrapper for characters, and utilities for searching,\n"
+    "storing, and generating NPCs from mob prototypes.");
   
   // make sure it loaded OK
   if (m == NULL)
diff -ruN ../nakedmudv3.7.9/src/scripts/pyevent.c src/scripts/pyevent.c
--- ../nakedmudv3.7.9/src/scripts/pyevent.c	2009-03-02 01:00:40.000000000 -0500
+++ src/scripts/pyevent.c	2009-04-05 13:00:58.000000000 -0400
@@ -170,12 +170,19 @@
 // the all methods that are contained within the event module
 PyMethodDef event_module_methods[] = {
   {"start_event",  PyEvent_start_event, METH_VARARGS,
-   "Add a new python event to the event queue."},
+   "start_event(owner, delay, event_func, data=None, arg='')\n\n"
+   "Queue a new delayed event, to go off after delay seconds. Events are\n"
+   "cancelled when their owner is extracted. Owners can be characters, \n"
+   "objects, rooms, or None. The event function should take three arguments:\n"
+   "the event owner, the event data, and the string argument. Data is an\n"
+   "optional argument that can be of any type. Arg is an optional argument\n"
+   "that must be a string." },
   {"start_update",  PyEvent_start_update, METH_VARARGS,
-   "Add a new python update to the event queue. Like an event, but readds "
-   "itself to the event queue after completion."},
+   "Deprecated. For repeating events, use events that manually re-queue\n"
+   "their selves." },
   {"interrupt_events_involving",  PyEvent_interrupt_event, METH_VARARGS,
-   "Interrupt all of the events involving the given object, room, or char."},
+   "interrupt_events_involving(thing)\n\n"
+   "Interrupt all events involving a given object, room, or character."},
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
@@ -185,5 +192,6 @@
 // implementation of pyevent.h
 //*****************************************************************************
 PyMODINIT_FUNC init_PyEvent(void) {
-  Py_InitModule3("event", event_module_methods, "The mud's event handler.");
+  Py_InitModule3("event", event_module_methods, 
+    "The event module handles delayed function calls.");
 }
diff -ruN ../nakedmudv3.7.9/src/scripts/pyexit.c src/scripts/pyexit.c
--- ../nakedmudv3.7.9/src/scripts/pyexit.c	2009-03-02 01:00:40.000000000 -0500
+++ src/scripts/pyexit.c	2009-04-04 23:47:36.000000000 -0400
@@ -658,55 +658,62 @@
 
     // add all of the basic getsetters
     PyExit_addGetSetter("uid", PyExit_getuid, NULL,
-			"returns the exit's universal ID nubmer");
+      "The exit's universal identification nubmer. Immutable.");
     PyExit_addGetSetter("spot_diff", PyExit_getspotdiff, PyExit_setspotdiff,
-			"integer value representing how hidden the exit is.");
+      "Integer value representing how hard to see the exit is.");
     PyExit_addGetSetter("hidden", PyExit_getspotdiff, PyExit_setspotdiff,
-			"integer value representing how hidden the exit is.");
+      "Alias for exit.Exit.spot_diff");
     PyExit_addGetSetter("pick_diff", PyExit_getpickdiff, PyExit_setpickdiff,
-			"integer value representing how hard lock is to pick.");
+      "Integer value representing how hard the exit's lock is to pick.");
     PyExit_addGetSetter("key", PyExit_getkey, PyExit_setkey,
-			"String or Obj value for obj class that unlocks exit.");
+      "An object prototype name that can be used to unlock this exit. Can be\n"
+      "set either by assigning a prototype name, or an actual object.");
     PyExit_addGetSetter("dest", PyExit_getdest, PyExit_setdest,
-			"String or Room value for room this exit leads to.");
+      "The room that this exit leads to. Can be set either by assigning a\n"
+      "world room key, or an actual room.");
     PyExit_addGetSetter("destproto", PyExit_getdestproto, NULL,
-			"return the class name of our our destiantion.");
+      "The world room key of our destination. Immutable.");
     PyExit_addGetSetter("name", PyExit_getname, PyExit_setname,
-			"The name of the door on the exit.");
+      "The name of the door for this exit, if any.");
     PyExit_addGetSetter("keywords", PyExit_getkeywords, PyExit_setkeywords,
-			"comma-separated string of the door's keywords.");
+      "A comma-separated string of the door's keywords.");
     PyExit_addGetSetter("opposite", PyExit_getopposite, PyExit_setopposite,
-			"if the exit is special, a dir name for the exit that "
-			"leads back to this exit's room.");
+      "if the exit is special, a dir name for the exit that leads back to\n"
+      "this exit's room.");
     PyExit_addGetSetter("desc", PyExit_getdesc, PyExit_setdesc,
-			"the long description of the exit when looked at.");
+      "The verbose description of the exit when, e.g., it is looked at.");
     PyExit_addGetSetter("leave_mssg", PyExit_getleavemssg, PyExit_setleavemssg,
-			"the special message sent when a char exits the room.");
+      "A message for when a character leaves a room via this exit.");
     PyExit_addGetSetter("enter_mssg", PyExit_getentermssg, PyExit_setentermssg, 
-		       "the special message sent when a char enters the room.");
+      "A message for when a char enters the room via this exit.");
     PyExit_addGetSetter("is_closable", PyExit_getclosable, NULL,
-			"true or false if the exit can be closed.");
+      "True or False if an exit can be closed. Immutable.");
     PyExit_addGetSetter("is_closed", PyExit_getclosed, NULL,
-			"true or false if the exit is closed.");
+      "True or False if an exit is closed. Immutable.");
     PyExit_addGetSetter("is_locked", PyExit_getlocked, NULL,
-			"true or false if the exit is locked.");
+      "True or False if an exit is locked.");
     PyExit_addGetSetter("room", PyExit_getroom, NULL,
-			"the room we are attached to.");
+      "The room we this exit is attached to. Immutable.");
 
     // add all of the basic methods
     PyExit_addMethod("makedoor", PyExit_makedoor, METH_VARARGS,
-		     "Make a door on the exit. Takes name, keywords, and "
-		     "optionally opposite, closed, locked, and key.");
+      "makedoor(name=None, keywords=None, opposite=None, closed=False, locked=False)\n\n"
+      "Create a door for the exit.");
     PyExit_addMethod("filldoor", PyExit_filldoor, METH_NOARGS,
-		     "remove a door that was made on the exit.");
-    PyExit_addMethod("open", PyExit_open, METH_VARARGS,
-		     "Opens the exit if there's a door. Also unlocks.");
-    PyExit_addMethod("close", PyExit_close, METH_VARARGS,
-		     "Close the exit's door if one exists.");
-    PyExit_addMethod("lock", PyExit_lock, METH_VARARGS,
-		     "Locks the exit if there's a door. Also closes.");
-    PyExit_addMethod("unlock", PyExit_unlock, METH_VARARGS,
-		     "Unlocks the exit's door if one exists.");
+      "filldoor()\n\n"
+      "Erase a door that was on the exit.");
+    PyExit_addMethod("open", PyExit_open, METH_NOARGS,
+      "open()\n\n"
+      "Opens the exit's door if it exists. Also unlocks.");
+    PyExit_addMethod("close", PyExit_close, METH_NOARGS,
+      "close()\n\n"
+      "Close the exit's door if it exists.");
+    PyExit_addMethod("lock", PyExit_lock, METH_NOARGS,
+      "lock()\n\n"
+      "Locks the exit's door if it exists. Also closes.");
+    PyExit_addMethod("unlock", PyExit_unlock, METH_NOARGS,
+      "unlock()\n\n"
+      "Unlocks the exit's door if it exists.");
 
     // add in all the getsetters and methods
     makePyType(&PyExit_Type, pyexit_getsetters, pyexit_methods);
